<?php
/*---------------------------------------------------------------*/
/*
    Titre : Calcul du lever et coucher du soleil n'importe quand et n'importe ou...                                       
                                                                                                                          
    URL   : https://phpsources.net/code_s.php?id=385
    Auteur           : Olravet                                                                                            
    Website auteur   : http://olravet.fr/                                                                                 
    Date dition     : 07 Mai 2008                                                                                        
    Date mise  jour : 22 Aout 2019
                                                                                      
    Rapport de la maj:                                                                                                    
    - fonctionnement du code vérifié                                                                                    
    - correction du code                                                                                                  
    - amélioration du code                                                                                               
*/
/*---------------------------------------------------------------*/

    if (!isset($fh)) {$fh = date("H") - gmdate("H") ;}
    if (!isset($La)) { $La = 48.833;}
    if (!isset($Lo)) { $Lo = -2.333;}
    if (!isset($ville)) { $ville = "Paris";}
    if (!isset($mois)) {$mois = date("m") ;}
    if (!isset($jour)) {$jour = date("d") ;}
    // Fuseau horaire et coordonnées géographiques
    $k = 0.0172024;
    $jm = 308.67;
    $jl = 21.55;
    $e = 0.0167;
    $ob = 0.4091;
    $PI= 3.1415926536;
    //Hauteur du soleil au lever et au coucher
    $dr = $PI/ 180;
    $hr = $PI/ 12;
    $ht = (-40 / 60);
    $ht = $ht * $dr;
    $La = $La * $dr;
    $Lo = $Lo * $dr;
    //Date
    if ($mois < 3) {
    $mois = $mois + 12;
    }
    //Heure TU du milieu de la journée
    $h = 12 + ($Lo / $hr);
    //Nombre de jours écoulés depuis le 1 Mars O h TU
    $J = floor(30.61 * ($mois + 1)) + $jour + ($h / 24) - 123;
    //Anomalie et longitude moyenne
    $M = $k * ($J - $jm);
    $L = $k * ($J - $jl);
    //Longitude vraie
    $S =$L + 2 * $e * Sin($M) + 1.25 * $e * $e * Sin(2 * $M);
    //Coordonnées rectangulaires du soleil dans le repère équatorial
    $X = Cos($S);
    $Y = Cos($ob) * Sin($S);
    $Z = Sin($ob) * Sin($S);
    //Equation du temps et déclinaison
    $R = $L;
    $rx = Cos($R) * $X + Sin($R) * $Y;
    $ry = -Sin($R) * $X + Cos($R) * $Y;
    $X = $rx;
    $Y = $ry;
    $ET = atan($Y / $X);
    $DC = atan($Z / Sqrt(1 - $Z * $Z));
    //Angle horaire au lever et au coucher
    $cs = (Sin($ht) - Sin($La) * Sin($DC)) / Cos($La) / Cos($DC);
    if ($cs > 1) { $CalculSol = "Ne se lève pas";}
    if ($cs < -1) { $CalculSol = "Ne se couche pas";}
    if ($cs == 0) {
    $ah = $PI / 2;
    }else{
    $ah = atan(Sqrt(1 - $cs * $cs) / $cs);
    }
    if ($cs < 0) { $ah = $ah + $PI;}
    //Lever du soleil
    $Pm = $h + $fh + ($ET - $ah) / $hr;
    if ($Pm < 0) { $Pm = $Pm + 24;}
    if ($Pm > 24) { $Pm = $Pm - 24;}
    $hs = floor($Pm);
    $Pm = floor(60 * ($Pm - $hs));
    if (strlen($hs)<2) {$hs = "0".$hs;}
    if (strlen($Pm)<2) {$Pm = "0".$Pm;}
    if (!isset($CalculSol)){
    $lev = $hs. ":" .$Pm;
    }else{
    $lev = "---";}
    //Coucher du soleil
    $Pm = $h + $fh + ($ET + $ah) /$hr;
    if ($Pm > 24) { $Pm = $Pm - 24;}
    if ($Pm < 0) { $Pm = $Pm + 24;}
    $hs = floor($Pm);
    $Pm = floor(60 * ($Pm - $hs));
    if (strlen($hs)<2) {$hs = "0".$hs;}
    if (strlen($Pm)<2) {$Pm = "0".$Pm;}
    if (!isset($CalculSol)){
    $couch = $hs. ":" .$Pm;
    }else{
    $couch  = "---";}
    echo "Horaires du Soleil à  ".$ville."<br />";
    echo "Lever = " .$lev ;
    echo "<br />";
    echo "Coucher = ". $couch;
?>